<?php

namespace MoAzureObjectSync\API;

use MoAzureObjectSync\Wrappers\wpWrapper;

class Authorization{
    private static $instance;

    public static function getController(){
        if(!isset(self::$instance)){
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }

    public function mo_azos_get_access_token_using_client_credentials($endpoints,$config,$scope){
        $client_secret = wpWrapper::mo_azos_decrypt_data($config['client_secret'],hash("sha256",$config['client_id']));
        $args = [
            'body' => [
                'grant_type' => 'client_credentials',
                'client_secret' => $client_secret,
                'client_id' => $config['client_id'],
                'scope' => $scope
            ],
            'headers' => [
                'Content-type' => 'application/x-www-form-urlencoded'
            ]
        ];

        $response = wp_remote_post(esc_url_raw($endpoints['token']),$args);
        if ( is_wp_error( $response ) ) {
            $error_message = $response->get_error_message();
            wp_die("Error Occurred : ".esc_html($error_message));
        } else {
            $body= json_decode($response["body"],true);
            if(isset($body["access_token"])){
                return $body["access_token"];
            }
        }
        return false;
    }

    public function mo_azos_get_request($url,$headers){
        $args = [
            'headers' => $headers
        ];
        $response = wp_remote_get(esc_url_raw($url),$args);
        if ( is_array( $response ) && ! is_wp_error( $response ) ) {
            return json_decode($response["body"],true);
        } else {
            wp_die("Error occurred: ".esc_html($response->get_error_message()));
        }
    }
}