<?php


namespace MoAzureObjectSync\View;

class adminView{

    private static $instance;

    public static function getView(){
        if(!isset(self::$instance)){
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }

    public function mo_azos_menu_display(){
        if( isset( $_GET[ 'tab' ] ) ) {
            $active_tab = sanitize_text_field($_GET['tab']);
        }else{
            $active_tab = 'app_config';
        }
        $this->mo_azos_display_tabs($active_tab);
    }

    private function mo_azos_display_tabs($active_tab){
        echo '<div style="display:flex;justify-content:space-between;align-items:flex-start;padding-top:20px;">
        <div style="width:65%;" id="mo_azos_container" class="mo-container">';
            $this->mo_azos_display__header_menu();
            $this->mo_azos_display__tabs($active_tab);
            $this->mo_azos_display__tab_content($active_tab);
        echo '</div>';
        $supportFormHandler = supportForm::getView();
        $supportFormHandler->mo_azos_display_support_form();
        echo'</div>';
    }

    private function mo_azos_display__header_menu(){
       ?>
        <div style="display: flex;">
            <img id="mo-ms-title-logo" src="<?php echo plugin_dir_url(MO_AZOS_PLUGIN_FILE).'images/miniorange.png';?>">
            <h1><label for="sync_integrator">User Sync for Azure Office365</label></h1>
        </div>
        <?php
    }

    private function mo_azos_display__tabs($active_tab){
        ?>
        <div class="mo-ms-tab ms-tab-background mo-ms-tab-border">
            <ul class="mo-ms-tab-ul">
                <li id="app_config" class="mo-ms-tab-li">
                    <a href="<?php echo esc_url_raw(add_query_arg('tab','app_config'));?>">
                        <div id="application_div_id" class="mo-ms-tab-li-div <?php
                        if($active_tab == 'app_config'){
                            echo 'mo-ms-tab-li-div-active';
                        }
                        ?>" aria-label="Application" title="Application Configuration" role="button" tabindex="0">
                            <div id="add_icon" class="mo-ms-tab-li-icon" >
                                <img  src="<?php echo plugin_dir_url(__FILE__).'../images/add.svg';?>">
                            </div>
                            <div id="add_app_label" class="mo-ms-tab-li-label">
                                Manage Application
                            </div>
                        </div>
                    </a>
                </li>
                <li id="user_sync" class="mo-ms-tab-li" role="presentation" title="user_sync">
                <a href="<?php echo add_query_arg('tab','manage_users');?>">
                    <div id="user_sync_div_id" class="mo-ms-tab-li-div <?php
                        if($active_tab == 'manage_users'){
                            echo 'mo-ms-tab-li-div-active';
                        }
                        ?>" aria-label="user_sync" title="User Management" role="button" tabindex="1">
                        <div id="user_sync_icon" class="mo-ms-tab-li-icon" >
                            <img  src="<?php echo plugin_dir_url(__FILE__).'../images/users.svg';?>">
                        </div>
                        <div id="user_sync_label" class="mo-ms-tab-li-label">
                            Users
                        </div>
                    </div>
                </a>
            </li>
            </ul>
        </div>
        <?php
    }

    private function mo_azos_display__tab_content($active_tab){
        $handler = self::getView();
        switch ($active_tab){
            case 'app_config':{
                $handler = appConfig::getView();
                break;
            }
            case 'manage_users':{
                $handler = manageUsers::getView();
                break;
            }

        }
        $handler->mo_azos_display__tab_details();
    }

    private function mo_azos_display__tab_details(){
       esc_html_e("Class missing. Please check if you've installed the plugin correctly.");
    }
}