<?php

namespace MoAzureObjectSync\View;
use MoAzureObjectSync\Wrappers\wpWrapper;

class appConfig{

    private static $instance;

    public static function getView(){
        if(!isset(self::$instance)){
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }

    public function mo_azos_display__tab_details(){

        $tiles_arr = [
            'app' => 'mo_azos_display__client_config',
            'provisioning' => 'mo_azos_display_provisioning_config'
        ];

        ?>
        <div class="mo-ms-tab-content" style="width: 70%">
            <h1>Configure Microsoft Graph Application</h1>
            <div>
                <div class="mo-ms-tab-content-left-border">
                    <?php
                        foreach ($tiles_arr as $key => $value){
                            $this->$value();
                        }
                    ?>
                </div>
            </div>
        </div>
        <?php
    }

    private function mo_azos_display__client_config(){
        $app = wpWrapper::mo_azos_get_option('mo_azos_application_config');
        $client_id = !empty($app['client_id'])?$app['client_id']:'';
        $redirect_uri = !empty($app['redirect_uri'])?$app['redirect_uri']:site_url();
        $tenant_id = !empty($app['tenant_id'])?$app['tenant_id']:'';
        $upn_id = !empty($app['upn_id'])?$app['upn_id']:'';
        if(isset($app['client_secret']) && !empty($app['client_secret'])){
            $client_secret = wpWrapper::mo_azos_decrypt_data($app['client_secret'],hash("sha256",$client_id));
        }else{
            $client_secret = '';
        }
        ?>
        <form class="mo_azos_ajax_submit_form" action="" method="post">
            <input type="hidden" name="option" id="app_config" value="mo_azos_client_config_option">
            <input type="hidden" name="mo_azos_tab" value="app_config">
            <?php wp_nonce_field('mo_azos_client_config_option');?>
            <div class="mo-ms-tab-content-tile">
                <div class="mo-ms-tab-content-tile-content">
                    <span style="font-size: 18px;font-weight: 200;display:flex;">1. Basic App Configuration </span>
                    <table class="mo-ms-tab-content-app-config-table">
                        <tr>
                            <td class="left-div"><span>Application ID <span style="color:red;font-weight:bold;">*</span></span></td>
                            <td class="right-div"><input placeholder="Enter Your Application (Client) ID" type="text" name="client_id" value="<?php echo esc_html($client_id);?>"></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Client Secrets <span style="color:red;font-weight:bold;">*</span></span></td>
                            <td class="right-div"><input placeholder="Enter Your Client Secret" type="password" name="client_secret" value="<?php echo esc_html($client_secret);?>"></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Redirect URI <span style="color:red;font-weight:bold;">*</span></span></td>
                            <td class="right-div"><input placeholder="Enter Redirect URI of Your Application" type="url" name="redirect_uri" value="<?php echo esc_html($redirect_uri);?>"></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Tenant ID <span style="color:red;font-weight:bold;">*</span></span></td>
                            <td class="right-div"><input placeholder="Enter Your Directory (Tenant) ID" type="text" name="tenant_id" value="<?php echo esc_html($tenant_id);?>"></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Test UPN/ID</span></td>
                            <td  class="right-div"><input placeholder="Enter UserPrincipalName/ID of User To Test (optional)" type="text" name="upn_id" value="<?php echo esc_html($upn_id);?>"></td>
                        </tr>

                        <tr><td colspan="2"></td></tr>
                    </table>
                    <div style="display: flex;justify-content:flex-start;align-items:center;">
                        <div style="display: flex;margin:10px;">
                            <input style="height:30px;" type="submit" id="saveButton" class="mo-ms-tab-content-button" value="Save">
                        </div>
                        <div style="display: flex;margin:10px;">
                            <input style="height:30px;" type="button" id="syncUsersButton" class="mo-ms-tab-content-button" value="Sync Users">
                        </div>
                        <div style="margin:10px;">
                            <input style="height:30px;" id="view_attributes" type="button" class="mo-ms-tab-content-button" value="Test Configuration" onclick="showAttributeWindow()">
                        </div>
                    </div>
                </div>
            </div>
        </form>
        <form id="sync_users" method="post" name="sync_users">
            <input type="hidden" name="option" value="mo_azos_client_sync_users_option">
            <input type="hidden" name="mo_azos_tab" value="app_config">
            <?php wp_nonce_field('mo_azos_client_sync_users_option');?>
        </form>
        <script>
            document.getElementById("syncUsersButton").addEventListener("click",function (){
                document.getElementById("sync_users").submit();
            });
            function showAttributeWindow(){
                document.getElementById("app_config").value = "mo_azos_app_test_config_option";
                var myWindow = window.open("<?php echo esc_url_raw($this->mo_azos_get_test_url()); ?>", "TEST User Attributes", "scrollbars=1 width=800, height=600");
            }
        </script>
        <?php
    }

    function mo_azos_display_provisioning_config(){
        ?>
        <form class="mo_azos_ajax_submit_form" id="app_config_provisioning_rate">
            <div class="mo-ms-tab-content-tile">
                <div class="mo-ms-tab-content-tile-content">
                    <span style="font-size: 18px;font-weight: 200;">2. Setup Provisioning Rate
                        <sup style="font-size: 12px;color:red;font-weight:600;">
                            [Available in Premium Plugin]
                        </sup>
                    </span>
                    <table class="mo-ms-tab-content-app-config-table">
                        <tr>
                            <td class="left-div" style="width: 35%"><span>Limit Provisioning Rate to(Results/Request)</span></td>
                            <td class="right-div"><input placeholder="Enter the limit provisioning rate" disabled style="border:1px solid #eee;cursor:not-allowed" type="number" name="request_rate" value=""></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Enable Automatic User Creation</span></td>
                            <td class="right-div">
                                <div style="display: flex">
                                    <div style="padding-right: 15px;padding-top: 2px;">
                                        <label class="switch">
                                            <input disabled type="checkbox" name="automatic_user_creation" >
                                            <span class="slider round"></span>
                                        </label>
                                    </div>
                                    <input disabled style="border:1px solid #eee;cursor:not-allowed" type="number" name="user_create_sync_interval" value="" placeholder="Fetch all user's details again in next * minutes">
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Enable Automatic User Deletion</span></td>
                            <td class="right-div">
                                <div style="display: flex">
                                    <div style="padding-right: 15px;padding-top: 2px;">
                                        <label class="switch">
                                            <input disabled type="checkbox" name="automatic_user_deletion">
                                            <span class="slider round"></span>
                                        </label>
                                    </div>
                                    <input disabled style="border:1px solid #eee;cursor:not-allowed" type="number" name="user_delete_sync_interval" value="" placeholder="Fetch deleted users again in next * minutes">
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <div style="display: flex">
                                    <input disabled style="background-color: #DCDAD1;border:none;cursor:not-allowed;" type="submit" class="mo-ms-tab-content-button" value="Save">
                                    <div class="loader-placeholder"></div>
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </form>
    <?php
    }

    private function mo_azos_get_test_url(){
        return admin_url('?option=testUser');
    }
}