<?php

namespace MoAzureObjectSync\View;
use MoAzureObjectSync\Wrappers\wpWrapper;

class manageUsers{

    private static $instance;

    public static function getView(){
        if(!isset(self::$instance)){
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }

    public function mo_azos_display__tab_details(){
        $tiles_arr = [
            'basic' => 'mo_azos_display_basic_attr_mapping',
            'picture' => 'mo_azos_display_basic_profile_pic_mapping',
            'custom' => 'mo_azos_display_advanced_attr_mapping'
        ];
    
        ?>
    
        <div class="mo-ms-tab-content">
            <h1>Configure Attribute Mapping</h1>
            <div style="width: 70%">
                <div class="mo-ms-tab-content-left-border">
                    <?php
                    foreach ($tiles_arr as $key => $value){
                        $this->$value();
                    }
                    ?>
                </div>
            </div>
        </div>
    <?php
    }
    
    public function mo_azos_display_basic_attr_mapping(){
        ?>
    
        <form class="mo_azos_ajax_submit_form" id="manage_users_save_basic_attr_mapping">
            <div class="mo-ms-tab-content-tile">
                <div class="mo-ms-tab-content-tile-content">
                    <span style="font-size: 18px;font-weight: 200;">1. Basic Attributes
                        <sup style="font-size: 12px;color:red;font-weight:600;">
                                [Available in Premium Plugin]
                        </sup>
                    </span>
                    <table class="mo-ms-tab-content-app-config-table">
                        <tr>
                            <td class="left-div"><span>Username</span></td>
                            <td class="right-div">
                                <input disabled style="border:1px solid #eee;cursor:not-allowed" placeholder="Enter attribute name for Username" type="text" name="user_login" value="">
                            </td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Email</span></td>
                            <td class="right-div"><input disabled style="border:1px solid #eee;cursor:not-allowed" placeholder="Enter attribute name for Email" type="text" name="email" value=""></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>First Name</span></td>
                            <td class="right-div"><input disabled style="border:1px solid #eee;cursor:not-allowed" placeholder="Enter attribute name for First Name" type="text" name="first_name" value=""></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Last Name</span></td>
                            <td class="right-div"><input disabled style="border:1px solid #eee;cursor:not-allowed" placeholder="Enter attribute name for Last Name" type="text" name="last_name" value=""></td>
                        </tr>
                        <tr>
                            <td class="left-div"><span>Display Name</span></td>
                            <td class="right-div"><input disabled style="border:1px solid #eee;cursor:not-allowed" placeholder="Enter attribute name for Display Name" type="text" name="display_name" value=""></td>
                        </tr>
                        <tr>
                            <td>
                                <div style="display: flex">
                                    <input disabled style="background-color: #DCDAD1;border:none;cursor:not-allowed;" type="submit" class="mo-ms-tab-content-button" value="Save">
                                    <div class="loader-placeholder"></div>
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </form>
    
    <?php
    }
    
    public function mo_azos_display_basic_profile_pic_mapping(){
        ?>
    
        <form class="mo_azos_ajax_submit_form" id="mo_azos_client_default_profile_image">
            <div class="mo-ms-tab-content-tile">
                <div class="mo-ms-tab-content-tile-content">
                    <span style="font-size: 18px;font-weight: 200;">2. Profile Picture Sync
                        <sup style="font-size: 12px;color:red;font-weight:600;">
                                [Available in Premium Plugin]
                        </sup>
                    </span>
                    <table class="mo-ms-tab-content-app-config-table">
                        <tr>
                            <td class="left-div"><span>Enable Profile Picture Sync</span></td>
                            <td class="right-div">
                                <div style="display: flex">
                                    <div style="padding-right: 15px;padding-top: 2px;">
                                        <label class="switch">
                                            <input disabled type="checkbox" name="profile_pic_sync">
                                            <span class="slider round"></span>
                                        </label>
                                    </div>
                                    <input disabled style="border:1px solid #eee;cursor:not-allowed" type="text" name="profile_pic_value" value="" placeholder="Base64Encoded image value for default user image. No image will be assigned if field kept empty.">
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <div style="display: flex">
                                    <input disabled style="background-color: #DCDAD1;border:none;cursor:not-allowed;" type="submit" class="mo-ms-tab-content-button" value="Save">
                                    <div class="loader-placeholder"></div>
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </form>
    <?php
    }
    
    public function mo_azos_display_advanced_attr_mapping(){
        ?>
    
        <form class="mo_azos_ajax_submit_form" id="manage_users_save_advanced_attr_mapping">
            <div class="mo-ms-tab-content-tile">
                <div class="mo-ms-tab-content-tile-content">
                    <span style="font-size: 18px;font-weight: 200;">3. Advanced Attributes
                        <sup style="font-size: 12px;color:red;font-weight:600;">
                            [Available in Premium Plugin]
                        </sup>
                    </span><br>
                    <table class="mo-ms-tab-content-app-config-table">
                        <tr>
                            <td colspan="2"><input disabled style="background-color: #DCDAD1;border:none;cursor:not-allowed;" type="button" class="mo-ms-tab-content-button" id="add_rows" value="Add Attribute" onclick="addMoreRows()"></td>
                        </tr>
                    </table>
                    <table id="attr_mapping" class="mo-azos-custom-attr-mapping-table">
                        <thead>
                        <tr>
                            <th class="left-div"><h4>Attribute Name</h4></th>
                            <th class="right-div"><h4>Attribute Value</h4></th>
                        </tr>
                        </thead>
                    </table>
                    <table class="mo-ms-tab-content-app-config-table">
                        <tr>
                            <td>
                                <div style="display: flex">
                                    <input disabled style="background-color: #DCDAD1;border:none;cursor:not-allowed;" type="submit" class="mo-ms-tab-content-button" value="Save">
                                    <div class="loader-placeholder"></div>
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </form>
    
    <?php
    }
    
}